#include "update_index.h"

void update_index( Index     & index,
                   ch_string      url,
                   StringSet   words,
                   bool      & ok )
{
    try {
        while( ! words.empty() ) {
            ch_string word = words.getAny() ;
            if( index.inDomain( word ) ) {
                // Add the file name to the set of filenames for this word.
                StringSet &fNameSet = index.atRef( word ) ;
                fNameSet.insert( url ) ; }
            else {
                // Add a new word to the index
                StringSet fNameSet ;
                fNameSet.insert( url ) ;
                index.add( word, fNameSet ) ; }

            words.remove( word ) ; }
        ok = true ;
    }
    catch( StringSet::SpaceException & ) {
        ok = false ; }
    catch( Index::SpaceException & ) {
        ok = false ; }
}
