/* test.cpp
   main function for testing student assignments.
   Author: Theodore Norvell
   Date:  May 1998

   Usage:
        test all 
            Run all tests.
            Return 0 ;
        test count
            Return a count of how many tests there are + 1000
        test N
            Run test numbered N where 0 <= N and N < the number of tests.

*/

#include <iostream>  // Standard I/O
#include <cstring>   // String comparisons

using namespace std ; 

int  testCount() ;
void doTest(int, int &) ;

int main(int argc, char **argv) {
    int testNumber ;
    bool doAll = false ;
    if( argc > 2 ) {
        cout << "Expected zero or one arguments.\n" ;
        return 999 ; }
    else if( argc == 1 ) {
        doAll = true ; }
    else if( 0==strcmp( argv[1], "count" ) ) {
        return testCount() ; }
    else if( 0==strcmp( argv[1], "all" ) ) {
        doAll = true ; }
    else {
        bool allDigits = true; 
        for(int i=0; argv[1][i]!=0 ; ++i) {
            allDigits = allDigits &&
                        ('0' <= argv[1][i] && argv[1][i] <= '9') ; }
        if( ! allDigits ) {
            cout << "Expected first argument to be a number, \"all\", or \"count\".\n" ;
            return 999 ;}
        else {
            testNumber = atoi( argv[1] ) ;
            if( testNumber < 0 || testNumber >= testCount() ) {
                cout << "Expect first argument between 0 and " << testCount()-1 << ".\n" ;
                return 999 ; }  } }
    
    if( doAll ) {
        for(int t=0 ; t < testCount() ; ++t ) {
            int res ;
            doTest( t, res ) ;
            if( res==0 ) { cout << "Test " << t << " passed\n\n" ; }
            else { cout << "Test " << t << " failed\n\n" ; } }
        return 0 ; }
    else {
        int res ;
        doTest( testNumber, res ) ;
        if( res==0 ) { cout << "Test " << testNumber << " passed\n\n" ; }
        else { cout << "Test " << testNumber << " failed\n\n" ; }
        return res ; } }
